"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const prometheus = require("prom-client");
const gcStats = require("prometheus-gc-stats");
const AdminPortPlugin_1 = require("../web/AdminPortPlugin");
class MetricsPlugin {
    constructor() {
        this.name = 'MetricsPlugin';
    }
    getName() {
        return this.name;
    }
    didStart(app, pluginContext) {
        this.prometheusTimer = prometheus.defaultMetrics();
        // prometheus.register.setDefaultLabels({app: app.getConfig('app.name', 'not_set')});
        const startGcStats = gcStats();
        startGcStats();
        const context = app.getContext();
        const express = pluginContext.get(AdminPortPlugin_1.default.CONTEXT_APP_KEY);
        if (express) {
            express.get('/metrics', async (req, res) => {
                res.type('text/plain');
                res.send(prometheus.register.metrics());
            });
        }
    }
    didStop() {
        if (this.prometheusTimer) {
            clearInterval(this.prometheusTimer);
        }
    }
}
exports.default = MetricsPlugin;
//# sourceMappingURL=MetricsPlugin.js.map